(ns com.aurellem.gb.saves
  (:use (com.aurellem.gb gb-driver))
  (:import [com.aurellem.gb.gb_driver SaveState]))

(defn pre-wild-battle []
  (read-state "prepare-for-battle"))

(defn pre-trainer-battle []
  (read-state "pre-trainer-battle"))

(defn rlm-pallet-town []
  (read-state "rlm-pallet-town"))

(defn talk-to-oak []
  (read-state "talk-to-oak"))

(defn normal-conv []
  (read-state "normal-conversation"))

(defn oak-battle []
  (read-state "oak-battle"))

(defn crit-fight []
  (read-state "battle-rival"))

(defn grass-edge []
  (read-state "grass' edge"))

(defn end-oak-conv []
  (read-state "end-oak-conversation"))


(defmacro gen-save [save-name]
  `(defn ~save-name
     ~(str "load " save-name " from disk.")
     []
     (read-state ~(str save-name))))

(gen-save cursor-item-1)
(gen-save cursor-item-2)
(gen-save cursor-item-3)
(gen-save cursor-item-4)
(gen-save cursor-item-5)
(gen-save cursor-item-6)

(gen-save at-mat)